// T-55A with Iraqi "Enigma" armour
// 
// by Jakko Westerbeke <jakko@xs4all.nl>, copyright 2003
// 
// Measurements for basic tank taken from the 1:35th scale Tamiya model 
// and plans by Karl Rosenlof in Military Modelling Vol. 29 No. 15 
// (24 Dec 1999 - 20 Jan 2000)
// Note that the tank is not intended to be highly-detailed; it just
// serves as a background for the armour sections.
// 
// Measurements for extra armour taken from actual tank in Tank Museum, 
// Bovington, UK, by Robert Lockie (thanks!) and the author.
sky_sphere {
   pigment {
      color rgb <1, 1, 1>
   }
}

light_source {
   <-20, 20, 0>, rgb <1, 1, 1>
   shadowless
}

light_source {
   <0, 20, -50>, rgb <1, 1, 1>
   shadowless
}

#declare Green = pigment {
   color rgb <0.0156863, 0.341176, 0.0666667>
}

#declare Infrared = texture {
   pigment {
      color rgb <0, 0, 0>
   }
   
   finish {
      reflection rgb <0, 0, 0>
   }
}

#declare Rubber = pigment {
   color rgb <0.184314, 0.184314, 0.184314>
}

#declare Sand = pigment {
   color rgb <0.79216, 0.83137, 0.68235>
}

#declare Sand_transparent = pigment {
   color rgbt <0.79216, 0.83137, 0.68235, 0.5>
}

#declare Rust = pigment {
   color rgb <0.635294, 0.388235, 0.243137>
}

#declare ArmourBlockHullBracket = union {
   //*PMName Brackets
   
   box {
      //*PMName Horizontal
      <0, -11, 0>, <20, 1, 4.5>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Uprights left
      linear_spline
      linear_sweep
      0, 1,
      5,
      <1, 0>, <15, 4.5>, <-25, 4.5>, <-11, 0>, <1, 0>
      scale <1, -1, 1>
      rotate z*90
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Uprights right
      linear_spline
      linear_sweep
      19, 20,
      5,
      <1, 0>, <15, 4.5>, <-25, 4.5>, <-11, 0>, <1, 0>
      scale <1, -1, 1>
      rotate z*90
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Bolt left
      linear_spline
      linear_sweep
      2, -12,
      7,
      <0.5, 1>, <1, 0>, <0.5, -1>, <-0.5, -1>, <-1, 0>, <-0.5, 1>, <0.5, 1>
      scale 1
      rotate <0, 0, 0>
      translate <4.5, 0, 2.25>
   }
   
   cylinder {
      //*PMName Bolt thread left
      <0, -12, 0>, <0, -13, 0>, 0.5
      scale 1
      rotate <0, 0, 0>
      translate <4.5, 0, 2.25>
   }
   
   prism {
      //*PMName Bolt right
      linear_spline
      linear_sweep
      2, -12,
      7,
      <0.5, 1>, <1, 0>, <0.5, -1>, <-0.5, -1>, <-1, 0>, <-0.5, 1>, <0.5, 1>
      scale 1
      rotate <0, 0, 0>
      translate <15.5, 0, 2.25>
   }
   
   cylinder {
      //*PMName Bolt thread right
      <0, -12, 0>, <0, -14, 0>, 0.5
      scale 1
      rotate <0, 0, 0>
      translate <15.5, 0, 2.25>
   }
   translate <0, 5, -4.5>
}

#declare ArmourBlockTurretBracket = union {
   //*PMName Brackets
   
   box {
      //*PMName Horizontal
      <-7.5, -6, 0>, <7.5, 1, 7>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Uprights left
      linear_spline
      linear_sweep
      6.5, 7.5,
      8,
      <1, 0>, <7.5, 4.5>, <7.5, 7>, <-13.5, 7>, <-13.5, 4.5>, <-6, 0>, <0, 0>, <1, 0>
      scale <1, -1, 1>
      rotate z*90
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Uprights right
      linear_spline
      linear_sweep
      -6.5, -7.5,
      8,
      <1, 0>, <7.5, 4.5>, <7.5, 7>, <-13.5, 7>, <-13.5, 4.5>, <-6, 0>, <0, 0>, <1, 0>
      scale <1, -1, 1>
      rotate z*90
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Bolt left
      linear_spline
      linear_sweep
      2, -7,
      7,
      <0.5, 1>, <1, 0>, <0.5, -1>, <-0.5, -1>, <-1, 0>, <-0.5, 1>, <0.5, 1>
      scale 1
      rotate <0, 0, 0>
      translate <-4, 0, 3.75>
   }
   
   cylinder {
      //*PMName Bolt thread left
      <0, -7, 0>, <0, -9, 0>, 0.5
      scale 1
      rotate <0, 0, 0>
      translate <-4, 0, 3.75>
   }
   
   prism {
      //*PMName Bolt right
      linear_spline
      linear_sweep
      2, -7,
      7,
      <0.5, 1>, <1, 0>, <0.5, -1>, <-0.5, -1>, <-1, 0>, <-0.5, 1>, <0.5, 1>
      scale 1
      rotate <0, 0, 0>
      translate <4, 0, 3.75>
   }
   
   cylinder {
      //*PMName Bolt thread right
      <0, -7, 0>, <0, -8, 0>, 0.5
      scale 1
      rotate <0, 0, 0>
      translate <4, 0, 3.75>
   }
   translate <0, 35, -7>
   rotate y*(-90)
}

#declare ArmourBolt = union {
   //*PMName Armour fixture bolt
   
   cylinder {
      //*PMName Disc
      <12.5, 0, 0>, <13, 0, 0>, 3.75
      scale <-1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cylinder {
      //*PMName Bolt
      <12.5, 0, 0>, <14, 0, 0>, 0.5
      scale <-1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Nut
      linear_spline
      linear_sweep
      12.5, 13.5,
      7,
      <0.5, 1>, <1, 0>, <0.5, -1>, <-0.5, -1>, <-1, 0>, <-0.5, 1>, <0.5, 1>
      scale 1
      rotate z*90
      translate <0, 0, 0>
   }
}

#declare ArmourHullFront = union {
   //*PMName Armour
   
   union {
      //*PMName Right mudguard block
      
      prism {
         //*PMName Block
         linear_spline
         linear_sweep
         -36, 36,
         5,
         <0, 80>, <-12.5, 80>, <-12.5, 103.5>, <0, 124.5>, <0, 80>
         scale <1, 1, -1>
         rotate x*90
         translate <0, 0, 0>
      }
      
      object {
         //*PMName Bolt right
         ArmourBolt
         scale 1
         rotate <0, 0, 0>
         translate <0, 96, 20>
      }
      
      object {
         //*PMName Bolt left
         ArmourBolt
         scale 1
         rotate <0, 0, 0>
         translate <0, 96, -20>
      }
      translate z*88
   }
   
   union {
      //*PMName Right slab
      
      difference {
         //*PMName Slab
         
         prism {
            //*PMName Slab
            linear_spline
            linear_sweep
            -50, 50,
            5,
            <0, 0>, <-12.5, 0>, <-12.5, 103>, <0, 124>, <0, 0>
            scale <1, 1, -1>
            rotate x*90
            translate <0, 0, 0>
         }
         
         box {
            //*PMName Hole
            <1, 7, 25>, <-14, 41, 6>
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
      }
      
      object {
         //*PMName Bolt top right
         ArmourBolt
         scale 1
         rotate <0, 0, 0>
         translate <0, 86, 30>
      }
      
      object {
         //*PMName Bolt top left
         ArmourBolt
         scale 1
         rotate <0, 0, 0>
         translate <0, 86, -35>
      }
      
      object {
         //*PMName Bolt bottom right
         ArmourBolt
         scale 1
         rotate <0, 0, 0>
         translate <0, 10, 30>
      }
      
      object {
         //*PMName Bolt bottom left
         ArmourBolt
         scale 1
         rotate <0, 0, 0>
         translate <0, 10, -35>
      }
   }
   
   union {
      //*PMName Left slab
      
      difference {
         //*PMName Slab
         
         prism {
            //*PMName Slab
            linear_spline
            linear_sweep
            -35, 35,
            5,
            <0, 0>, <-12.5, 0>, <-12.5, 93>, <0, 113>, <0, 0>
            scale <1, 1, -1>
            rotate x*90
            translate <0, 0, 0>
         }
         
         box {
            //*PMName Hole
            <1, 7, 5>, <-14, 41, -13.5>
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
      }
      
      object {
         //*PMName Bolt top right
         ArmourBolt
         scale 1
         rotate <0, 0, 0>
         translate <0, 86, 28>
      }
      
      object {
         //*PMName Bolt top left
         ArmourBolt
         scale 1
         rotate <0, 0, 0>
         translate <0, 86, -29>
      }
      
      object {
         //*PMName Bolt bottom right
         ArmourBolt
         scale 1
         rotate <0, 0, 0>
         translate <0, 10, 28>
      }
      
      object {
         //*PMName Bolt bottom left
         ArmourBolt
         scale 1
         rotate <0, 0, 0>
         translate <0, 10, -29>
      }
      translate z*(-88)
   }
   
   union {
      //*PMName Left mudguard block
      
      prism {
         //*PMName Block
         linear_spline
         linear_sweep
         -36.5, 36.5,
         5,
         <0, 80>, <-12.5, 80>, <-12.5, 103>, <0, 124>, <0, 80>
         scale <1, 1, -1>
         rotate x*90
         translate <0, 0, 0>
      }
      
      object {
         //*PMName Bolt right
         ArmourBolt
         scale 1
         rotate <0, 0, 0>
         translate <0, 96, 20>
      }
      
      object {
         //*PMName Bolt left
         ArmourBolt
         scale 1
         rotate <0, 0, 0>
         translate <0, 96, -20>
      }
      translate z*(-162)
   }
   
   pigment {
      Sand
   }
   scale 0.02857
   rotate z*(-60)
   translate <0.1, 1.1, 1>
}

#declare ArmourHullsideMountings = union {
   //*PMName Supports
   
   box {
      //*PMName Outer bar
      <0, -5, -5>, <300, 5, 0>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   box {
      //*PMName Horizontal 1
      <28, -5, -5>, <33, 5, -65>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Corner brace 1
      linear_spline
      linear_sweep
      2.5, 3.5,
      4,
      <33, -5>, <43, -5>, <33, -15>, <33, -5>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Diagonal 1
      linear_spline
      linear_sweep
      0, 5,
      5,
      <33, -65>, <126, -5>, <133, -5>, <40, -65>, <33, -65>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   box {
      //*PMName Horizontal 2
      <133, 0, -5>, <138, 5, -65>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Diagonal 2
      linear_spline
      linear_sweep
      0, 5,
      5,
      <205, -65>, <145, -5>, <138, -5>, <198, -65>, <205, -65>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Corner brace 2
      linear_spline
      linear_sweep
      2.5, 3.5,
      4,
      <210, -5>, <220, -5>, <210, -15>, <210, -5>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   box {
      //*PMName Horizontal 3
      <205, 0, -5>, <210, 5, -65>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Corner brace 3
      linear_spline
      linear_sweep
      2.5, 3.5,
      4,
      <205, -5>, <195, -5>, <205, -15>, <205, -5>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Diagonal 3
      linear_spline
      linear_sweep
      0, 5,
      5,
      <210, -65>, <236, -5>, <243, -5>, <217, -65>, <210, -65>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   box {
      //*PMName Horizontal 4
      <243, 0, -5>, <248, 5, -65>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Diagonal 4
      linear_spline
      linear_sweep
      0, 5,
      5,
      <295, -65>, <255, -5>, <248, -5>, <288, -65>, <295, -65>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Corner brace 4
      linear_spline
      linear_sweep
      2.5, 3.5,
      4,
      <295, -5>, <285, -5>, <295, -15>, <295, -5>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   box {
      //*PMName Horizontal 5
      <295, -5, 0>, <300, 5, -65>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   translate <0, 0, 0>
}

#declare ArmourHullsideLeft = union {
   //*PMName Armour
   
   union {
      //*PMName Supports
      
      object {
         //*PMName Supports
         ArmourHullsideMountings
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      prism {
         //*PMName Support brace 1
         linear_spline
         linear_sweep
         171, 172,
         9,
         <-15, 0>, <-65, 0>, <-65, 20>, <-55, 20>, <-47.5, 18>, <-47.5, 13>, <-27.5, 13>, <-15, 10>, <-15, 0>
         scale <-1, -1, 1>
         rotate <0, 90, 90>
         translate <0, 0, 0>
      }
      
      prism {
         //*PMName Support brace 2
         linear_spline
         linear_sweep
         204, 205,
         6,
         <-15, 0>, <-65, 0>, <-65, 20>, <-40, 20>, <-15, 10>, <-15, 0>
         scale <-1, -1, 1>
         rotate <0, 90, 90>
         translate <0, 0, 0>
      }
      
      prism {
         //*PMName Support brace 3
         linear_spline
         linear_sweep
         226, 227,
         9,
         <-15, 0>, <-65, 0>, <-65, 20>, <-55, 20>, <-47.5, 18>, <-47.5, 13>, <-27.5, 13>, <-15, 10>, <-15, 0>
         scale <-1, -1, 1>
         rotate <0, 90, 90>
         translate <0, 0, 0>
      }
      
      prism {
         //*PMName Support brace 4
         linear_spline
         linear_sweep
         294, 295,
         6,
         <-20, 0>, <-65, 0>, <-65, 20>, <-40, 20>, <-20, 10>, <-20, 0>
         scale <-1, -1, 1>
         rotate <0, 90, 90>
         translate <0, 0, 0>
      }
   }
   
   union {
      //*PMName Blocks
      
      prism {
         //*PMName Block 1
         linear_spline
         linear_sweep
         0, 21.5,
         5,
         <0, 0>, <31, 0>, <31, 56>, <0, 40>, <0, 0>
         
         pigment {
            Sand_transparent
         }
         scale <1, 1, -1>
         rotate x*90
         translate x*2.5
      }
      
      box {
         //*PMName Block 2
         <0, 0, 0>, <31, 57, 21.5>
         scale 1
         rotate <0, 0, 0>
         translate x*33.5
         inverse
      }
      
      box {
         //*PMName Block 3
         <0, 0, 0>, <31, 60, 21.5>
         scale 1
         rotate <0, 0, 0>
         translate x*65
      }
      
      box {
         //*PMName Block 4
         <0, 0, 0>, <31, 62, 21>
         scale 1
         rotate <0, 0, 0>
         translate x*96.5
      }
      
      box {
         //*PMName Block 5
         <0, 0, 0>, <31, 63, 21.5>
         scale 1
         rotate <0, 0, 0>
         translate x*128
      }
      
      box {
         //*PMName Block 6
         <0, 0, 0>, <31.5, 64.5, 22>
         scale 1
         rotate <0, 0, 0>
         translate x*159.5
      }
      
      box {
         //*PMName Block 7
         <0, 0, 0>, <31, 64.5, 22>
         scale 1
         rotate <0, 0, 0>
         translate x*191.5
      }
      
      box {
         //*PMName Block 8
         <0, 0, 0>, <31, 64.5, 21.5>
         scale 1
         rotate <0, 0, 0>
         translate x*223
      }
      rotate z*(-0.32)
      translate y*(-33)
   }
   
   union {
      //*PMName Brackets
      
      difference {
         //*PMName Bracket 1
         
         object {
            //*PMName Bracket
            ArmourBlockHullBracket
            scale 1
            rotate <0, 0, 0>
            translate x*7
         }
         
         box {
            //*PMName Cut-off
            <6, 7, 1>, <9, 25, -5>
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         pigment {
            Sand_transparent
         }
      }
      
      object {
         //*PMName Bracket 2
         ArmourBlockHullBracket
         scale 1
         rotate <0, 0, 0>
         translate x*40
      }
      
      object {
         //*PMName Bracket 3
         ArmourBlockHullBracket
         scale 1
         rotate <0, 0, 0>
         translate x*71
      }
      
      object {
         //*PMName Bracket 4
         ArmourBlockHullBracket
         scale 1
         rotate <0, 0, 0>
         translate x*103
      }
      
      object {
         //*PMName Bracket 5
         ArmourBlockHullBracket
         scale 1
         rotate <0, 0, 0>
         translate x*133
      }
      
      object {
         //*PMName Bracket 6
         ArmourBlockHullBracket
         scale 1
         rotate <0, 0, 0>
         translate x*165
      }
      
      object {
         //*PMName Bracket 7
         ArmourBlockHullBracket
         scale 1
         rotate <0, 0, 0>
         translate x*197
      }
      
      object {
         //*PMName Bracket 8
         ArmourBlockHullBracket
         scale 1
         rotate <0, 0, 0>
         translate x*230
      }
   }
   scale <0.02857, 0.02857, -0.02857>
   translate <1.5, 2.2, -4.85>
   
   pigment {
      Sand
   }
}

#declare ArmourHullsideRight = union {
   //*PMName Armour
   
   union {
      //*PMName Supports
      
      object {
         //*PMName Supports
         ArmourHullsideMountings
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      prism {
         //*PMName Support brace 1
         linear_spline
         linear_sweep
         207, 208,
         4,
         <-20, 5>, <-65, 5>, <-65, 15>, <-20, 5>
         scale <-1, -1, 1>
         rotate <0, 90, 90>
         translate <0, 0, 0>
      }
      
      prism {
         //*PMName Support brace 2
         linear_spline
         linear_sweep
         242, 243,
         6,
         <-20, 5>, <-65, 5>, <-65, 15>, <-40, 15>, <-20, 10>, <-20, 5>
         scale <-1, -1, 1>
         rotate <0, 90, 90>
         translate <0, 0, 0>
      }
      
      prism {
         //*PMName Support brace 3
         linear_spline
         linear_sweep
         297, 298,
         4,
         <-20, 5>, <-65, 5>, <-65, 15>, <-20, 5>
         scale <-1, -1, 1>
         rotate <0, 90, 90>
         translate <0, 0, 0>
      }
   }
   
   union {
      //*PMName Blocks
      
      prism {
         //*PMName Block 1
         linear_spline
         linear_sweep
         0, 21.5,
         5,
         <0, 0>, <31, 0>, <31, 56>, <0, 40>, <0, 0>
         scale <1, 1, -1>
         rotate x*90
         translate x*3
      }
      
      box {
         //*PMName Block 2
         <0, 0, 0>, <31, 57.5, 21.5>
         scale 1
         rotate <0, 0, 0>
         translate x*34.5
      }
      
      box {
         //*PMName Block 3
         <0, 0, 0>, <31, 61, 21.5>
         scale 1
         rotate <0, 0, 0>
         translate x*66
      }
      
      box {
         //*PMName Block 4
         <0, 0, 0>, <31, 62, 21.5>
         scale 1
         rotate <0, 0, 0>
         translate x*97.5
      }
      
      box {
         //*PMName Block 5
         <0, 0, 0>, <31.5, 62.5, 21.5>
         scale 1
         rotate <0, 0, 0>
         translate x*129
      }
      
      box {
         //*PMName Block 6
         <0, 0, 0>, <31, 64, 21.5>
         scale 1
         rotate <0, 0, 0>
         translate x*161
      }
      
      box {
         //*PMName Block 7
         <0, 0, 0>, <31, 64, 22>
         scale 1
         rotate <0, 0, 0>
         translate x*192.5
      }
      
      box {
         //*PMName Block 8
         <0, 0, 0>, <31, 64.5, 22>
         scale 1
         rotate <0, 0, 0>
         translate x*224
      }
      translate y*(-35)
   }
   
   union {
      //*PMName Brackets
      
      difference {
         //*PMName Bracket 1
         
         object {
            //*PMName Bracket
            ArmourBlockHullBracket
            scale 1
            rotate <0, 0, 0>
            translate x*7
         }
         
         box {
            //*PMName Cut-off
            <6, 7, 1>, <10, 25, -5>
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
      }
      
      object {
         //*PMName Bracket 2
         ArmourBlockHullBracket
         scale 1
         rotate <0, 0, 0>
         translate x*40
      }
      
      object {
         //*PMName Bracket 3
         ArmourBlockHullBracket
         scale 1
         rotate <0, 0, 0>
         translate x*71
      }
      
      object {
         //*PMName Bracket 4
         ArmourBlockHullBracket
         scale 1
         rotate <0, 0, 0>
         translate x*102
      }
      
      object {
         //*PMName Bracket 5
         ArmourBlockHullBracket
         scale 1
         rotate <0, 0, 0>
         translate x*133
      }
      
      object {
         //*PMName Bracket 6
         ArmourBlockHullBracket
         scale 1
         rotate <0, 0, 0>
         translate x*166
      }
      
      object {
         //*PMName Bracket 7
         ArmourBlockHullBracket
         scale 1
         rotate <0, 0, 0>
         translate x*197
      }
      
      object {
         //*PMName Bracket 8
         ArmourBlockHullBracket
         scale 1
         rotate <0, 0, 0>
         translate x*230
      }
   }
   scale 0.02857
   translate <1.5, 2.2, 4.85>
   
   pigment {
      Sand
   }
}
//*PMRawBegin
#macro TurretSprings(startX, startY, endX, endY, springZ, stepsN)

	#declare stepSizeX = (endX - startX) / stepsN;
	#declare stepSizeY = (endY - startY) / stepsN;

	#while (startX <= endX)
		torus {
		   3, 0.35
		   rotate <10, 0, 100>
		   translate <startX, startY, springZ>
		}
		#declare startX = startX + stepSizeX;
		#declare startY = startY + stepSizeY;
	#end

#end
//*PMRawEnd

#declare ArmourStruts = union {
   //*PMName Struts
   
   difference {
      //*PMName Brackets
      
      union {
         //*PMName Plates
         
         prism {
            //*PMName Bracket inside
            linear_spline
            linear_sweep
            -1, 0,
            6,
            <0, 0>, <57, 0>, <57, 15.5>, <25, 45.5>, <0, 45.5>, <0, 0>
            scale <1, 1, -1>
            rotate x*90
            translate <0, 0, 0>
         }
         
         prism {
            //*PMName Bracket outside
            linear_spline
            linear_sweep
            5, 6,
            6,
            <0, 0>, <57, 0>, <57, 15.5>, <25, 45.5>, <0, 45.5>, <0, 0>
            scale <1, 1, -1>
            rotate x*90
            translate <0, 0, 0>
         }
      }
      
      cylinder {
         //*PMName Cut-out
         <0, 0, -2>, <0, 0, 7>, 45.5
         scale <0.55, 1, 1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
   }
   
   prism {
      //*PMName Filler
      linear_spline
      linear_sweep
      0, 6,
      6,
      <43.7168, 0>, <57, 0>, <57, 15.5>, <25, 46>, <11.0841, 46>, <43.7168, 0>
      scale <1, 1, -1>
      rotate x*90
      translate <0, 0, 0>
   }
   
   box {
      //*PMName Upper beam
      <25, 32, 0>, <125, 42, 5>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Lower beam
      linear_spline
      linear_sweep
      0, 5,
      5,
      <49.5, 19>, <148, 36>, <148, 47>, <41, 27.75>, <49.5, 19>
      scale <1, 1, -1>
      rotate x*90
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Side plate
      linear_spline
      linear_sweep
      5, 5.5,
      6,
      <52.894, 19.522>, <148, 36>, <148, 47>, <119.5, 42>, <30.022, 42>, <52.894, 19.522>
      scale <1, 1, -1>
      rotate x*90
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Corner brace
      linear_spline
      linear_sweep
      41, 42,
      4,
      <138, 0>, <148, -0>, <148, -10>, <138, 0>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Bolt 1
      linear_spline
      linear_sweep
      -2, 8,
      7,
      <0.5, 1>, <1, 0>, <0.5, -1>, <-0.5, -1>, <-1, 0>, <-0.5, 1>, <0.5, 1>
      scale 1
      rotate x*90
      translate <26, 41, 0>
   }
   
   prism {
      //*PMName Bolt 2
      linear_spline
      linear_sweep
      -2, 8,
      7,
      <0.5, 1>, <1, 0>, <0.5, -1>, <-0.5, -1>, <-1, 0>, <-0.5, 1>, <0.5, 1>
      scale 1
      rotate x*90
      translate <38, 30, 0>
   }
   
   prism {
      //*PMName Bolt 3
      linear_spline
      linear_sweep
      -2, 8,
      7,
      <0.5, 1>, <1, 0>, <0.5, -1>, <-0.5, -1>, <-1, 0>, <-0.5, 1>, <0.5, 1>
      scale 1
      rotate x*90
      translate <33, 30, 0>
   }
   
   prism {
      //*PMName Bolt 4
      linear_spline
      linear_sweep
      -2, 8,
      7,
      <0.5, 1>, <1, 0>, <0.5, -1>, <-0.5, -1>, <-1, 0>, <-0.5, 1>, <0.5, 1>
      scale 1
      rotate x*90
      translate <44, 19, 0>
   }
   
   prism {
      //*PMName Bolt 5
      linear_spline
      linear_sweep
      -2, 8,
      7,
      <0.5, 1>, <1, 0>, <0.5, -1>, <-0.5, -1>, <-1, 0>, <-0.5, 1>, <0.5, 1>
      scale 1
      rotate x*90
      translate <49, 19, 0>
   }
   
   prism {
      //*PMName Bolt 6
      linear_spline
      linear_sweep
      -2, 8,
      7,
      <0.5, 1>, <1, 0>, <0.5, -1>, <-0.5, -1>, <-1, 0>, <-0.5, 1>, <0.5, 1>
      scale 1
      rotate x*90
      translate <42, 7, 0>
   }
   
   prism {
      //*PMName Bolt 7
      linear_spline
      linear_sweep
      -2, 8,
      7,
      <0.5, 1>, <1, 0>, <0.5, -1>, <-0.5, -1>, <-1, 0>, <-0.5, 1>, <0.5, 1>
      scale 1
      rotate x*90
      translate <50, 7, 0>
   }
   translate z*72
   scale 0.02857
   
   pigment {
      Sand
   }
}

#declare ArmourTurretMounting = union {
   //*PMName Mounting
   
   prism {
      //*PMName Vertical
      linear_spline
      linear_sweep
      0, 5,
      5,
      <0, 0>, <9.11356, 0>, <40.6118, 38.0852>, <35.2, 42.528>, <0, 0>
      scale <1, 1, -1>
      rotate x*90
      translate x*37.635
   }
   
   box {
      //*PMName Top
      <0, -7, 0>, <13, 0, 5>
      scale 1
      rotate z*(-39.4)
      translate <72.8121, 42.5251, 0>
   }
   
   box {
      //*PMName Bottom
      <0, 0, 0>, <25, 7, 5>
      scale 1
      rotate <-0, 0, 0>
      translate x*43.737
   }
   translate z*(-24)
}

#declare ArmourTurretLeft = union {
   //*PMName Armour
   
   union {
      //*PMName Block 1 (front)
      
      intersection {
         //*PMName Block
         
         prism {
            //*PMName Side view
            linear_spline
            linear_sweep
            -36.5, 36.5,
            5,
            <0, 0>, <36, 0>, <72.9, 42.7>, <25, 33.7>, <0, 0>
            scale 1
            rotate x*(-90)
            translate <0, 0, 0>
         }
         
         prism {
            //*PMName Top view
            linear_spline
            linear_sweep
            -1, 43,
            5,
            <0, -36.5>, <0, 36.5>, <72.9, 15.1>, <72.9, -15.1>, <0, -36.5>
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
      }
      
      box {
         //*PMName Strut front
         <0, -7, 0>, <13, 0, 5>
         scale 1
         rotate z*(-39.4)
         translate <56.4412, 23.8582, 2.77671>
      }
      
      box {
         //*PMName Strut rear
         <0, -7, 0>, <13, 0, 5>
         scale 1
         rotate z*(-39.4)
         translate <49.8631, 15.8958, -11.3376>
      }
      
      union {
         //*PMName Hinge
         
         cylinder {
            //*PMName Main hinge
            <0, 0, -20>, <0, 0, 20>, 3
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         cylinder {
            //*PMName Front
            <0, 0, 18>, <0, 0, 13>, 4
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         cylinder {
            //*PMName Centre
            <0, 0, -5>, <0, 0, 5>, 5
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         cylinder {
            //*PMName Rear
            <0, 0, -18>, <0, 0, -13>, 4
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         box {
            //*PMName Leaf springs
            <-0.5, -1, -30>, <0.5, 1, 30>
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         prism {
            //*PMName Turret mount front
            linear_spline
            linear_sweep
            13.5, 16,
            4,
            <3, 3>, <13, -10>, <5, -13>, <3, 3>
            scale <1, 1, -1>
            rotate x*90
            translate <0, 0, 0>
         }
         
         prism {
            //*PMName Block mount
            linear_spline
            linear_sweep
            -1.25, 1.25,
            5,
            <-4.48698, -2.12184>, <2.75633, -3.88684>, <-19.2874, -23.2437>, <-21.2701, -21.4262>, <-4.48698, -2.12184>
            scale <1, 1, -1>
            rotate x*90
            translate <0, 0, 0>
         }
         
         prism {
            //*PMName Turret mount rear
            linear_spline
            linear_sweep
            -15, -17.5,
            4,
            <3, 3>, <13, -10>, <5, -13>, <3, 3>
            scale <1, 1, -1>
            rotate x*90
            translate <0, 0, 0>
         }
         translate <82, 50, 0>
      }
      
      union {
         //*PMName Springs
         
         prism {
            //*PMName Turret mount front
            linear_spline
            linear_sweep
            0, 1,
            5,
            <-2, 0>, <2, 0>, <1, 5>, <-1, 5>, <-2, 0>
            scale <1, 1, -1>
            rotate <90, -5, 0>
            translate <102, 45, 10>
         }
         
         prism {
            //*PMName Turret mount rear
            linear_spline
            linear_sweep
            0, 1,
            5,
            <-2, 0>, <2, 0>, <1, 5>, <-1, 5>, <-2, 0>
            scale <1, 1, -1>
            rotate x*90
            translate <102, 45, -8>
         }
         
         prism {
            //*PMName Block mount front
            linear_spline
            linear_sweep
            0, 1,
            5,
            <-2, 0>, <2, 0>, <1, 5>, <-1, 5>, <-2, 0>
            scale <1, 1, -1>
            rotate <90, 0, 10>
            translate <44.4437, 37.445, 10>
         }
         
         prism {
            //*PMName Block mount rear
            linear_spline
            linear_sweep
            0, 1,
            5,
            <-2, 0>, <2, 0>, <1, 5>, <-1, 5>, <-2, 0>
            scale <1, 1, -1>
            rotate <90, 0, 10>
            translate <44.444, 37.445, -8>
         }
         //*PMRawBegin
         TurretSprings(82, 54, 102, 49, 10, 15)
         TurretSprings(82, 54, 102, 49, -8, 15)
         TurretSprings(44, 37.5, 82, 54, 10, 30)
         TurretSprings(44, 37.5, 82, 54, -8, 30)
         //*PMRawEnd
      }
      rotate y*(-39.1)
      translate <-37.643, 0, 67.893>
   }
   
   union {
      //*PMName Block 2
      
      intersection {
         //*PMName Block
         
         prism {
            //*PMName Side view
            linear_spline
            linear_sweep
            -28, 28,
            5,
            <0, 0>, <37.5, 0>, <72.9, 42.7>, <25, 33.7>, <0, 0>
            scale 1
            rotate x*(-90)
            translate <0, 0, 0>
         }
         
         prism {
            //*PMName Top view
            linear_spline
            linear_sweep
            -1, 43,
            5,
            <0, -28>, <0, 28>, <72.9, 19.2>, <72.9, -19.2>, <0, -28>
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
      }
      
      object {
         //*PMName Mounting
         ArmourTurretMounting
         scale <1, 1, -1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      box {
         //*PMName Horizontal top
         <0, -5, -19>, <7.5, 0, 20>
         scale 1
         rotate z*(-39.4)
         translate <68.0713, 37.057, 0>
      }
      
      box {
         //*PMName Horizontal bottom
         <0, -5, -23>, <7.5, 0, 20>
         scale 1
         rotate z*(-39.4)
         translate <47.5063, 12.1389, 0>
      }
      
      object {
         //*PMName Bracket top
         ArmourBlockTurretBracket
         scale 1
         rotate z*(-39.4)
         translate <45.9888, 10.0878, 1>
      }
      
      object {
         //*PMName Bracket bottom
         ArmourBlockTurretBracket
         scale <1, -1, 1>
         rotate z*(-39.4)
         translate <66.7138, 35.2556, 1>
      }
      
      union {
         //*PMName Locking device
         
         cylinder {
            //*PMName Pin
            <0, 0, -20>, <0, 0, 2>, 0.5
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         cylinder {
            //*PMName Front
            <0, 0, 0>, <0, 0, -6>, 3.5
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         cylinder {
            //*PMName Rear
            <0, 0, -13>, <0, 0, -19>, 3.5
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         union {
            //*PMName Spring
            
            torus {
               //*PMName "Coil" 1
               3, 0.2
               scale 1
               rotate <100, -10, 0>
               translate z*(-7)
            }
            
            torus {
               //*PMName "Coil" 2
               3, 0.2
               scale 1
               rotate <100, -10, 0>
               translate z*(-8.5)
            }
            
            torus {
               //*PMName "Coil" 3
               3, 0.2
               scale 1
               rotate <100, -10, 0>
               translate z*(-10)
            }
            
            torus {
               //*PMName "Coil" 4
               3, 0.2
               scale 1
               rotate <100, -10, 0>
               translate z*(-11.5)
            }
            
            torus {
               //*PMName "Coil" 5
               3, 0.2
               scale 1
               rotate <100, -10, 0>
               translate z*(-13)
            }
         }
         
         torus {
            //*PMName Pull ring
            3, 0.2
            scale 1
            rotate x*(-10)
            translate z*(-22.5)
         }
         translate <47.2256, 41.5524, 21.9656>
      }
      rotate y*(-62)
      translate <11, 0, 27>
   }
   
   union {
      //*PMName Block 3
      
      intersection {
         //*PMName Block
         
         prism {
            //*PMName Side view
            linear_spline
            linear_sweep
            -28, 28,
            5,
            <0, 0>, <37.5, 0>, <72.9, 42.7>, <25, 33.7>, <0, 0>
            scale 1
            rotate x*(-90)
            translate <0, 0, 0>
         }
         
         prism {
            //*PMName Top view
            linear_spline
            linear_sweep
            -1, 43,
            5,
            <0, -28>, <0, 28>, <72.9, 19.2>, <72.9, -19.2>, <0, -28>
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
      }
      
      object {
         //*PMName Mounting
         ArmourTurretMounting
         scale <1, 1, -1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      box {
         //*PMName Horizontal top
         <0, -5, -19>, <7.5, 0, 20>
         scale 1
         rotate z*(-39.4)
         translate <68.0713, 37.057, 0>
      }
      
      box {
         //*PMName Horizontal bottom
         <0, -5, -23>, <7.5, 0, 20>
         scale 1
         rotate z*(-39.4)
         translate <47.5063, 12.1389, 0>
      }
      
      object {
         //*PMName Bracket top
         ArmourBlockTurretBracket
         scale 1
         rotate z*(-39.4)
         translate <46.1106, 10.0878, 1>
      }
      
      object {
         //*PMName Bracket bottom
         ArmourBlockTurretBracket
         scale <1, -1, 1>
         rotate z*(-39.4)
         translate <66.7138, 35.2556, 1>
      }
      rotate y*(-76)
      translate <64, 0, 7>
   }
   
   union {
      //*PMName Block 4 (rear)
      
      intersection {
         //*PMName Block
         
         prism {
            //*PMName Side view
            linear_spline
            linear_sweep
            -28, 28,
            5,
            <0, 0>, <37.5, 0>, <72.9, 42.7>, <25, 33.7>, <0, 0>
            scale 1
            rotate x*(-90)
            translate <0, 0, 0>
         }
         
         prism {
            //*PMName Top view
            linear_spline
            linear_sweep
            -1, 43,
            5,
            <0, -28>, <0, 28>, <72.9, 19.2>, <72.9, -19.2>, <0, -28>
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
      }
      
      object {
         //*PMName Mounting front
         ArmourTurretMounting
         scale <1, 1, -1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      union {
         //*PMName Mounting rear
         
         object {
            //*PMName Mounting
            ArmourTurretMounting
            scale <1, 1, -1>
            rotate <0, 0, 0>
            translate z*(-40)
         }
         
         prism {
            //*PMName Plate
            linear_spline
            linear_sweep
            0, 1,
            5,
            <37.5, 0>, <63.872, 0>, <82.837, 34.285>, <72.788, 42.456>, <37.5, 0>
            scale <1, 1, -1>
            rotate x*90
            translate z*(-22)
         }
         rotate y*(-8)
         translate <-2, 0, -7>
      }
      
      box {
         //*PMName Horizontal top
         <0, -5, -17>, <7.5, 0, 20>
         scale 1
         rotate z*(-39.4)
         translate <68.0713, 37.057, 0>
      }
      
      box {
         //*PMName Horizontal bottom
         <0, -5, -17>, <7.5, 0, 20>
         scale 1
         rotate z*(-39.4)
         translate <47.5063, 12.1389, 0>
      }
      
      object {
         //*PMName Bracket top
         ArmourBlockTurretBracket
         scale 1
         rotate z*(-39.4)
         translate <46.2324, 10.0878, 2>
      }
      
      object {
         //*PMName Bracket bottom
         ArmourBlockTurretBracket
         scale <1, -1, 1>
         rotate z*(-39.4)
         translate <66.8356, 35.0121, 2>
      }
      rotate y*(-90)
      translate x*120
   }
   
   pigment {
      Sand
   }
   translate y*13
   scale 0.02857
}

#declare ArmourTurretRear = union {
   //*PMName Armour
   
   union {
      //*PMName Panels
      
      box {
         //*PMName Bar
         <143, 36.5, -78>, <148, 46.5, 78>
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      box {
         //*PMName Block 1 (left)
         <0, 0, 0>, <12.5, 72.5, 31.5>
         scale 1
         rotate <0, 0, 0>
         translate <148, 0, -63.5>
      }
      
      object {
         //*PMName Bracket 1
         ArmourBlockHullBracket
         scale 1
         rotate y*90
         translate <148, 41.5, -38>
      }
      
      box {
         //*PMName Block 2
         <0, 0, 0>, <12.5, 71.5, 31>
         scale 1
         rotate <0, 0, 0>
         translate <148, 0, -31.5>
      }
      
      object {
         //*PMName Bracket 2
         ArmourBlockHullBracket
         scale 1
         rotate y*90
         translate <148, 41.5, -6>
      }
      
      box {
         //*PMName Block 3
         <0, 0, 0>, <12.5, 72, 31>
         scale 1
         rotate <0, 0, 0>
         translate x*148
      }
      
      object {
         //*PMName Bracket 3
         ArmourBlockHullBracket
         scale 1
         rotate y*90
         translate <148, 41.5, 25>
      }
      
      box {
         //*PMName Block 4 (right)
         <0, 0, 0>, <12.5, 72, 31.5>
         scale 1
         rotate <0, 0, 0>
         translate <148, 0, 31.5>
      }
      
      object {
         //*PMName Bracket 4
         ArmourBlockHullBracket
         scale 1
         rotate y*90
         translate <148, 41.5, 57>
      }
      scale 0.02857
   }
   
   object {
      //*PMName Struts right
      ArmourStruts
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   object {
      //*PMName Struts left
      ArmourStruts
      scale <1, 1, -1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   box {
      //*PMName Box support 1
      <2.6, 0.95, -2.1>, <2.7, 1.05, 2.1>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   box {
      //*PMName Box support 2
      <3.5, 0.95, -2.1>, <3.6, 1.05, 2.1>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   difference {
      //*PMName Box support 3
      
      union {
         box {
            //*PMName Left
            <3.45, 1.2, -2.25>, <3.6, 1.35, -1.6>
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         box {
            //*PMName Right
            <3.45, 1.2, 2.25>, <3.6, 1.35, 1.6>
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
      }
      
      box {
         //*PMName Tube inside
         <3.47, 1.22, -2.3>, <3.58, 1.33, 2.3>
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
   }
   
   box {
      //*PMName Box support 4
      <2.7, 0.95, -1>, <3.5, 1.05, -1.1>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   box {
      //*PMName Box support 5
      <2.7, 0.95, 1>, <3.5, 1.05, 1.1>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   pigment {
      Sand
   }
   translate <11.2, 3.2, 0>
}

#declare ArmourTurretRight = union {
   //*PMName Armour
   
   union {
      //*PMName Block 1 (front)
      
      intersection {
         //*PMName Block
         
         prism {
            //*PMName Side view
            linear_spline
            linear_sweep
            -33, 33,
            5,
            <0, 0>, <36, 0>, <72.9, 42.7>, <25, 33.7>, <0, 0>
            scale 1
            rotate x*(-90)
            translate <0, 0, 0>
         }
         
         prism {
            //*PMName Top view
            linear_spline
            linear_sweep
            -1, 43,
            5,
            <0, -33>, <0, 33>, <72.9, 24>, <72.9, -24>, <0, -33>
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
      }
      
      union {
         //*PMName Mounting
         
         object {
            //*PMName Mounting
            ArmourTurretMounting
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         prism {
            //*PMName Plate
            linear_spline
            linear_sweep
            0, 1,
            5,
            <37.5, 0>, <63.872, 0>, <82.837, 34.285>, <72.788, 42.456>, <37.5, 0>
            scale <1, 1, -1>
            rotate x*90
            translate z*(-19)
         }
         rotate y*8
         translate <2.5, 0, 52>
      }
      
      box {
         //*PMName Horizontal top
         <0, -5, -22>, <7.5, 0, 20>
         scale 1
         rotate z*(-39.4)
         translate <68.0713, 37.057, 0>
      }
      
      box {
         //*PMName Horizontal bottom
         <0, -5, -28>, <7.5, 0, 22>
         scale 1
         rotate z*(-39.4)
         translate <47.1409, 12.6261, 0>
      }
      
      object {
         //*PMName Bracket top
         ArmourBlockTurretBracket
         scale 1
         rotate z*(-39.4)
         translate <45.3798, 10.2096, 0>
      }
      
      object {
         //*PMName Bracket bottom
         ArmourBlockTurretBracket
         scale <1, -1, 1>
         rotate z*(-39.4)
         translate <66.2266, 35.7428, 0>
      }
      rotate y*(-48)
      translate <-39, 0, 63>
   }
   
   union {
      //*PMName Block 2
      
      intersection {
         //*PMName Block
         
         prism {
            //*PMName Side view
            linear_spline
            linear_sweep
            -28, 28,
            5,
            <0, 0>, <37.5, 0>, <72.9, 42.7>, <25, 33.7>, <0, 0>
            scale 1
            rotate x*(-90)
            translate <0, 0, 0>
         }
         
         prism {
            //*PMName Top view
            linear_spline
            linear_sweep
            -1, 43,
            5,
            <0, -28>, <0, 28>, <72.9, 19.2>, <72.9, -19.2>, <0, -28>
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
      }
      
      object {
         //*PMName Mounting
         ArmourTurretMounting
         scale 1
         rotate <0, 0, 0>
         translate z*43
      }
      
      box {
         //*PMName Horizontal top
         <0, -5, -19>, <7.5, 0, 20>
         scale 1
         rotate z*(-39.4)
         translate <68.0713, 37.057, 0>
      }
      
      box {
         //*PMName Horizontal bottom
         <0, -5, -23>, <7.5, 0, 20>
         scale 1
         rotate z*(-39.4)
         translate <47.5063, 12.1389, 0>
      }
      
      object {
         //*PMName Bracket top
         ArmourBlockTurretBracket
         scale 1
         rotate z*(-39.4)
         translate <45.867, 9.84426, 0>
      }
      
      object {
         //*PMName Bracket bottom
         ArmourBlockTurretBracket
         scale <1, -1, 1>
         rotate z*(-39.4)
         translate <66.592, 35.3774, 0>
      }
      rotate y*(-62)
      translate <11, 0, 27>
   }
   
   union {
      //*PMName Block 3
      
      intersection {
         //*PMName Block
         
         prism {
            //*PMName Side view
            linear_spline
            linear_sweep
            -28, 28,
            5,
            <0, 0>, <37.5, 0>, <72.9, 42.7>, <25, 33.7>, <0, 0>
            scale 1
            rotate x*(-90)
            translate <0, 0, 0>
         }
         
         prism {
            //*PMName Top view
            linear_spline
            linear_sweep
            -1, 43,
            5,
            <0, -28>, <0, 28>, <72.9, 19.2>, <72.9, -19.2>, <0, -28>
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
      }
      
      object {
         //*PMName Mounting
         ArmourTurretMounting
         scale 1
         rotate <0, 0, 0>
         translate z*43
      }
      
      box {
         //*PMName Horizontal top
         <0, -5, -19>, <7.5, 0, 20>
         scale 1
         rotate z*(-39.4)
         translate <68.0713, 37.057, 0>
      }
      
      box {
         //*PMName Horizontal bottom
         <0, -5, -23>, <7.5, 0, 20>
         scale 1
         rotate z*(-39.4)
         translate <47.5063, 12.1389, 0>
      }
      
      object {
         //*PMName Bracket top
         ArmourBlockTurretBracket
         scale 1
         rotate z*(-39.4)
         translate <45.8232, 9.71105, 0>
      }
      
      object {
         //*PMName Bracket bottom
         ArmourBlockTurretBracket
         scale <1, -1, 1>
         rotate z*(-39.4)
         translate <66.5482, 35.2718, 0>
      }
      rotate y*(-76)
      translate <64, 0, 7>
   }
   
   union {
      //*PMName Block 4 (rear)
      
      intersection {
         //*PMName Block
         
         prism {
            //*PMName Side view
            linear_spline
            linear_sweep
            -28, 28,
            5,
            <0, 0>, <37.5, 0>, <72.9, 42.7>, <25, 33.7>, <0, 0>
            scale 1
            rotate x*(-90)
            translate <0, 0, 0>
         }
         
         prism {
            //*PMName Top view
            linear_spline
            linear_sweep
            -1, 43,
            5,
            <0, -28>, <0, 28>, <72.9, 19.2>, <72.9, -19.2>, <0, -28>
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
      }
      
      object {
         //*PMName Mounting front
         ArmourTurretMounting
         scale 1
         rotate <0, 0, 0>
         translate z*43
      }
      
      box {
         //*PMName Mounting centre
         <0, 0, 0>, <7, 38, 5>
         scale 1
         rotate z*(-39.4)
         translate <44.662, 7.7674, 12>
      }
      
      union {
         //*PMName Mounting rear
         
         difference {
            //*PMName Mounting
            
            object {
               //*PMName Mounting
               ArmourTurretMounting
               scale 1
               rotate <0, 0, 0>
               translate <0, 0, 0>
            }
            
            cylinder {
               //*PMName Hole
               <60, 2.5, -25>, <60, 2.5, -18>, 1
               scale 1
               rotate <0, 0, 0>
               translate <0, 0, 0>
            }
         }
         
         prism {
            //*PMName Rear plate
            linear_spline
            linear_sweep
            -2, -3,
            7,
            <37, 0>, <55, 0>, <58.5, 6.1155>, <67, 6.7174>, <82.683, 34.118>, <72, 42.456>, <37, 0>
            scale <1, 1, -1>
            rotate x*90
            translate z*(-22)
         }
         rotate y*(-8)
         translate <-2, 0, -4>
      }
      
      box {
         //*PMName Horizontal top
         <0, -5, -17>, <7.5, 0, 17>
         scale 1
         rotate z*(-39.4)
         translate <68.0713, 37.057, 0>
      }
      
      box {
         //*PMName Horizontal bottom
         <0, -5, -18>, <7.5, 0, 17>
         scale 1
         rotate z*(-39.4)
         translate <47.5063, 12.1389, 0>
      }
      
      object {
         //*PMName Bracket top
         ArmourBlockTurretBracket
         scale 1
         rotate z*(-39.4)
         translate <46.0773, 9.91922, 0>
      }
      
      object {
         //*PMName Bracket bottom
         ArmourBlockTurretBracket
         scale <1, -1, 1>
         rotate z*(-39.4)
         translate <66.8023, 35.2488, 0>
      }
      
      union {
         //*PMName Hinge front
         
         cylinder {
            //*PMName Top (blockside)
            <80.5, 44, 1>, <80.5, 44, 3.5>, 3.75
            scale 1
            rotate <0, 0, 0>
            translate <-1.01383, 0.65175, 0>
         }
         
         box {
            //*PMName Bottom (blockside)
            <0, 0, 1>, <7.5, 11, 3.5>
            scale 1
            rotate z*(-39.8)
            translate <69.598, 38.605, 0>
         }
         
         cylinder {
            //*PMName Top (turretside)
            <80.5, 44, -3.5>, <80.5, 44, -1>, 3.75
            scale 1
            rotate <0, 0, 0>
            translate <-1.01383, 0.65175, 0>
         }
         
         box {
            //*PMName Bottom (turretside)
            <0, -2.5, -3.5>, <7.5, 10, -1>
            scale 1
            rotate z*39.8
            translate <82.8429, 34.7902, 0>
         }
         translate z*14
      }
      
      union {
         //*PMName Hinge rear
         
         cylinder {
            //*PMName Top (blockside)
            <80.5, 44, 1>, <80.5, 44, 3.5>, 3.75
            scale 1
            rotate <0, 0, 0>
            translate <-1.01383, 0.65175, 0>
         }
         
         box {
            //*PMName Bottom (blockside)
            <0, 0, 1>, <7.5, 11, 3.5>
            scale 1
            rotate z*(-39.8)
            translate <69.598, 38.605, 0>
         }
         
         cylinder {
            //*PMName Top (turretside)
            <80.5, 44, -3.5>, <80.5, 44, -1>, 3.75
            scale 1
            rotate <0, 0, 0>
            translate <-1.01383, 0.65175, 0>
         }
         
         box {
            //*PMName Bottom (turretside)
            <0, 0.5, -3.5>, <7.5, 10, -1>
            scale 1
            rotate z*39.8
            translate <82.8429, 34.7902, 0>
         }
         translate z*(-15)
      }
      
      cylinder {
         //*PMName Hinge pin
         <80.5, 44, -24.5>, <80.5, 44, 21.5>, 1.5
         scale 1
         rotate <0, 0, 0>
         translate <-1.0138, 0.65175, 0>
      }
      rotate y*(-90)
      translate x*120
   }
   
   pigment {
      Sand
   }
   rotate z*(-1)
   translate y*13
   scale <0.02857, 0.02857, -0.02857>
}

#declare DriveSprocket = difference {
   //*PMName Sprocket
   
   union {
      //*PMName Basic wheel
      
      cylinder {
         //*PMName Inner ring
         <0, 0, 0>, <0, 0, 0.2>, 0.75
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Inner thick bit
         <0, 0, 0.2>, <0, 0, 0.4>, 0.55
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cone {
         //*PMName Inner cone
         <0, 0, 0.4>, 0.55,
         <0, 0, 0.6>, 0.35
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Inner narrow bit
         <0, 0, 0.6>, <0, 0, 1>, 0.35
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cone {
         //*PMName Outer cone
         <0, 0, 1>, 0.35,
         <0, 0, 1.2>, 0.75
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Outer ring
         <0, 0, 1.2>, <0, 0, 1.4>, 0.75
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
   }
   
   cone {
      //*PMName Outer dish-shape
      <0, 0, 1.2>, 0.3,
      <0, 0, 1.5>, 0.7
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Cut-out 1
      linear_spline
      linear_sweep
      0.9, 1.5,
      6,
      <0.1, 0.35>, <0.1, 0.6>, <0.425, 0.425>, <0.6, 0.1>, <0.35, 0.1>, <0.1, 0.35>
      scale <1, 1, -1>
      rotate x*90
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Cut-out 2
      linear_spline
      linear_sweep
      0.9, 1.5,
      6,
      <0.1, 0.35>, <0.1, 0.6>, <0.425, 0.425>, <0.6, 0.1>, <0.35, 0.1>, <0.1, 0.35>
      scale <1, 1, -1>
      rotate <90, 0, 90>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Cut-out 3
      linear_spline
      linear_sweep
      0.9, 1.5,
      6,
      <0.1, 0.35>, <0.1, 0.6>, <0.425, 0.425>, <0.6, 0.1>, <0.35, 0.1>, <0.1, 0.35>
      scale <1, 1, -1>
      rotate <90, 0, 180>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Cut-out 4
      linear_spline
      linear_sweep
      0.9, 1.5,
      6,
      <0.1, 0.35>, <0.1, 0.6>, <0.425, 0.425>, <0.6, 0.1>, <0.35, 0.1>, <0.1, 0.35>
      scale <1, 1, -1>
      rotate <90, 0, 270>
      translate <0, 0, 0>
   }
   translate <15.9, 0.9, 3.1>
}

#declare FuelTank = difference {
   //*PMName Fuel tank
   
   superellipsoid {
      //*PMName Basic shape
      <0.1, 0.1>
      scale <1.3, 0.3, 0.75>
      rotate <0, 0, 0>
      translate <1.3, 2.5, 3.85>
   }
   
   superellipsoid {
      //*PMName Edge
      <0.05, 0.05>
      scale <1.45, 0.05, 0.9>
      rotate <0, 0, 0>
      translate <1.3, 2.5, 3.85>
   }
   
   plane {
      //*PMName Cut-off corner
      <0, -1, 0>, 0
      scale 1
      rotate <-20, 0, 10>
      translate <0, 2.6, 3.1>
   }
}

#declare IdlerWheel = union {
   //*PMName Idler
   
   difference {
      //*PMName Wheels
      
      union {
         //*PMName Inner & outer
         
         difference {
            //*PMName Rims
            
            cylinder {
               //*PMName Outer
               <0, 0, 0>, <0, 0, 1>, 0.7
               scale 1
               rotate <0, 0, 0>
               translate <0, 0, 0>
            }
            
            cylinder {
               //*PMName Inner
               <0, 0, -0.1>, <0, 0, 1.1>, 0.65
               scale 1
               rotate <0, 0, 0>
               translate <0, 0, 0>
            }
         }
         
         prism {
            //*PMName Spokes 1
            linear_spline
            linear_sweep
            -0.03, 0.03,
            7,
            <0.68, 0>, <0.68, 1>, <0.4, 0.7>, <-0.4, 0.7>, <-0.68, 1>, <-0.68, 0>, <0.68, 0>
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         prism {
            //*PMName Spokes 2
            linear_spline
            linear_sweep
            -0.03, 0.03,
            7,
            <0.68, 0>, <0.68, 1>, <0.4, 0.7>, <-0.4, 0.7>, <-0.68, 1>, <-0.68, 0>, <0.68, 0>
            scale 1
            rotate z*36
            translate <0, 0, 0>
         }
         
         prism {
            //*PMName Spokes 3
            linear_spline
            linear_sweep
            -0.03, 0.03,
            7,
            <0.68, 0>, <0.68, 1>, <0.4, 0.7>, <-0.4, 0.7>, <-0.68, 1>, <-0.68, 0>, <0.68, 0>
            scale 1
            rotate z*72
            translate <0, 0, 0>
         }
         
         prism {
            //*PMName Spokes 4
            linear_spline
            linear_sweep
            -0.03, 0.03,
            7,
            <0.68, 0>, <0.68, 1>, <0.4, 0.7>, <-0.4, 0.7>, <-0.68, 1>, <-0.68, 0>, <0.68, 0>
            scale 1
            rotate z*108
            translate <0, 0, 0>
         }
         
         prism {
            //*PMName Spokes 5
            linear_spline
            linear_sweep
            -0.03, 0.03,
            7,
            <0.68, 0>, <0.68, 1>, <0.4, 0.7>, <-0.4, 0.7>, <-0.68, 1>, <-0.68, 0>, <0.68, 0>
            scale 1
            rotate z*144
            translate <0, 0, 0>
         }
      }
      
      cylinder {
         //*PMName Gap between wheels
         <0, 0, 0.4>, <0, 0, 0.6>, 0.8
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Rim cut-outs 1
         <0, 0.75, 1>, <0, -0.75, 1>, 0.15
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Rim cut-outs 2
         <0, 0.75, 1>, <0, -0.75, 1>, 0.15
         scale 1
         rotate z*36
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Rim cut-outs 3
         <0, 0.75, 1>, <0, -0.75, 1>, 0.15
         scale 1
         rotate z*72
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Rim cut-outs 4
         <0, 0.75, 1>, <0, -0.75, 1>, 0.15
         scale 1
         rotate z*108
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Rim cut-outs 5
         <0, 0.75, 1>, <0, -0.75, 1>, 0.15
         scale 1
         rotate z*144
         translate <0, 0, 0>
      }
   }
   
   cylinder {
      //*PMName Hub
      <0, 0, -0.1>, <0, 0, 0.7>, 0.4
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   sphere {
      //*PMName Hubcap
      <0, 0, 0>, 0.325
      scale <1, 1, 0.5>
      rotate <0, 0, 0>
      translate z*0.7
   }
   translate <0.7, 0.8, 3.3>
}

#declare Mudguard = union {
   //*PMName Mudguard
   
   difference {
      //*PMName Front curve
      
      cylinder {
         //*PMName Outer
         <0, 1.25, 2.65>, <0, 1.25, 4.7>, 0.95
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Inner
         <0, 1.25, 2.65>, <0, 1.25, 4.8>, 0.75
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      prism {
         linear_spline
         linear_sweep
         2.7, 4.8,
         7,
         <0, 1.25>, <0, 2.5>, <1.3, 2.5>, <1.3, 0>, <-1, 0>, <-1, 1.25>, <0, 1.25>
         scale <1, 1, -1>
         rotate x*90
         translate <0, 0, 0>
      }
      scale <1.5, 1, 1>
      translate x*0.9
   }
   
   box {
      //*PMName Main length
      <0.9, 2.1, 2.65>, <16.6, 2.2, 4.7>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   box {
      //*PMName Rear section
      <0, -0.1, 2.95>, <0.6, 0, 4.7>
      scale 1
      rotate z*(-40)
      translate <16.6, 2.2, 0>
   }
   
   box {
      //*PMName Mud flap
      <0, -0.02, 2.95>, <0.6, 0, 4.7>
      
      pigment {
         Rubber
      }
      scale 1
      rotate z*(-44.7)
      translate <17.0539, 1.81096, 0>
   }
}

#declare Roadwheel = union {
   //*PMName Wheels
   
   difference {
      //*PMName Tyre
      
      cylinder {
         //*PMName Outer
         <0, 0, 0.13>, <0, 0, 0.57>, 1.15
         
         pigment {
            Rubber
         }
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Inner
         <0, 0, 0.1>, <0, 0, 0.6>, 1
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      pigment {
         Rubber
      }
   }
   
   difference {
      //*PMName Wheel
      
      cylinder {
         //*PMName Outer
         <0, 0, 0.125>, <0, 0, 0.575>, 1
         
         pigment {
            Rubber
         }
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Inner
         <0, 0, 0.2>, <0, 0, 0.6>, 0.95
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Hole 1
         <0, 0.4, 0.1>, <0, 0.4, 0.3>, 0.16
         scale <1, 1.5, 1>
         rotate z*36
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Hole 2
         <0, 0.4, 0.1>, <0, 0.4, 0.3>, 0.16
         scale <1, 1.5, 1>
         rotate z*108
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Hole 3
         <0, 0.4, 0.1>, <0, 0.4, 0.3>, 0.16
         scale <1, 1.5, 1>
         rotate z*180
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Hole 4
         <0, 0.4, 0.1>, <0, 0.4, 0.3>, 0.16
         scale <1, 1.5, 1>
         rotate z*252
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Hole 5
         <0, 0.4, 0.1>, <0, 0.4, 0.3>, 0.16
         scale <1, 1.5, 1>
         rotate z*324
         translate <0, 0, 0>
      }
   }
   
   cone {
      //*PMName Spoke 1
      <0, 0.3, 0>, 0.1,
      <0, 0.95, 0>, 0.3
      scale <1, 1, 0.5>
      rotate <0, 0, 0>
      translate z*0.2
   }
   
   cone {
      //*PMName Spoke 2
      <0, 0.3, 0>, 0.1,
      <0, 0.95, 0>, 0.3
      scale <1, 1, 0.5>
      rotate z*72
      translate z*0.2
   }
   
   cone {
      //*PMName Spoke 3
      <0, 0.3, 0>, 0.1,
      <0, 0.95, 0>, 0.3
      scale <1, 1, 0.5>
      rotate z*144
      translate z*0.2
   }
   
   cone {
      //*PMName Spoke 4
      <0, 0.3, 0>, 0.1,
      <0, 0.95, 0>, 0.3
      scale <1, 1, 0.5>
      rotate z*216
      translate z*0.2
   }
   
   cone {
      //*PMName Spoke 5
      <0, 0.3, 0>, 0.1,
      <0, 0.95, 0>, 0.3
      scale <1, 1, 0.5>
      rotate z*288
      translate z*0.2
   }
   
   cylinder {
      //*PMName Hub
      <0, 0, 0>, <0, 0, 0.35>, 0.35
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   sphere {
      //*PMName Hubcap
      <0, 0, 0>, 0.275
      scale <1, 1, 0.5>
      rotate <0, 0, 0>
      translate z*0.35
   }
}

#declare Roadwheels = union {
   //*PMName Wheels
   
   object {
      //*PMName Outer wheel
      Roadwheel
      scale 1
      rotate <0, 0, 0>
      translate <0, -0.1, 3.775>
   }
   
   object {
      //*PMName Inner wheel
      Roadwheel
      scale <1, 1, -1>
      rotate z*36
      translate <0, -0.1, 3.775>
   }
}

#declare Suspension = union {
   //*PMName Roadwheels
   
   object {
      //*PMName Wheel 1
      Roadwheels
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   object {
      //*PMName Wheel 2
      Roadwheels
      scale 1
      rotate <0, 0, 0>
      translate x*3.2
   }
   
   object {
      //*PMName Wheel 3
      Roadwheels
      scale 1
      rotate <0, 0, 0>
      translate x*5.85
   }
   
   object {
      //*PMName Wheel 4
      Roadwheels
      scale 1
      rotate <0, 0, 0>
      translate x*8.5
   }
   
   object {
      //*PMName Wheel 5
      Roadwheels
      scale 1
      rotate <0, 0, 0>
      translate x*11.15
   }
}

#declare Hull = union {
   //*PMName T-55 Hull
   
   prism {
      //*PMName Basic shape
      linear_spline
      linear_sweep
      -2.9, 2.9,
      8,
      <0, 1>, <1.3, 0>, <14.8, 0>, <16.1, 0.6>, <16.8, 2.7>, <16.5, 2.8>, <3.2, 2.8>, <0, 1>
      scale <1, 1, -1>
      rotate x*90
      translate <0, 0, 0>
   }
   
   cylinder {
      //*PMName Turret ring upper
      <8.2, 2.8, 0>, <8.2, 2.7, 0>, 3.6
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cone {
      //*PMName Turret ring lower
      <8.2, 2.7, 0>, 3.6,
      <8.2, 2.2, 0>, 2.9
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   box {
      //*PMName Engine deck front grilles
      <13.7, 2.8, -2.7>, <15, 2.9, 2.7>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   box {
      //*PMName Engine deck rear grilles
      <15.4, 2.8, -2.7>, <16.2, 2.9, 2.85>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   object {
      //*PMName Mudguard right
      Mudguard
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   object {
      //*PMName Fuel tank right front
      FuelTank
      scale 1
      rotate <0, 0, 0>
      translate x*10.1
   }
   
   object {
      //*PMName Fuel tank right rear
      FuelTank
      scale 1
      rotate y*180
      translate <15.75, 0, 7.7>
   }
   
   difference {
      //*PMName Mudguard left
      
      object {
         //*PMName Mudguard
         Mudguard
         scale <1, 1, -1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      box {
         //*PMName Exhaust space
         <11.8, 2.05, -2.9>, <13.3, 2.35, -4.8>
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
   }
   
   difference {
      //*PMName Exhaust
      
      prism {
         //*PMName Outer
         linear_spline
         linear_sweep
         11.8, 13.3,
         8,
         <2.05, -2.6>, <2.05, -2.9>, <2.05, -4.7>, <2.35, -4.7>, <2.35, -3.8>, <2.95, -3>, <2.95, -2.6>, <2.05, -2.6>
         scale <1, -1, 1>
         rotate z*90
         translate <0, 0, 0>
      }
      
      box {
         //*PMName Inner
         <11.9, 2.15, -2.9>, <13.2, 2.25, -4.8>
         
         pigment {
            Rubber
         }
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
   }
   
   prism {
      //*PMName Stowage box left rear
      linear_spline
      linear_sweep
      0, 1.15,
      5,
      <0, 0>, <0, 0.8>, <2.3, 0.7>, <2.3, 0>, <0, 0>
      scale <1, -1, -1>
      rotate x*90
      translate <13.4, 2.2, -3.35>
   }
   
   box {
      //*PMName Stowage box right front
      <0, 0, 0>, <3.5, 0.5, 0.6>
      scale 1
      rotate <0, 0, 0>
      translate <2.6, 2.2, 4>
   }
   
   superellipsoid {
      //*PMName Oil tank
      <0.3, 0.3>
      scale <0.8, 0.3, 0.5>
      rotate <0, 0, 0>
      translate <12.55, 2.65, -4>
   }
   
   object {
      //*PMName Idler right
      IdlerWheel
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   object {
      //*PMName Idler left
      IdlerWheel
      scale <1, 1, -1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   object {
      //*PMName Roadwheels right
      Suspension
      scale 1
      rotate <0, 0, 0>
      translate x*2.6
   }
   
   object {
      //*PMName Roadwheels left
      Suspension
      scale <1, 1, -1>
      rotate <0, 0, 0>
      translate x*3
   }
   
   object {
      //*PMName Drive sprocket right
      DriveSprocket
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   object {
      //*PMName Drive sprocket left
      DriveSprocket
      scale <1, 1, -1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   union {
      //*PMName Track right
      
      difference {
         //*PMName Idler
         
         cylinder {
            //*PMName Outer
            <0.7, 0.8, 3>, <0.7, 0.8, 4.6>, 0.85
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         cylinder {
            //*PMName Inner
            <0.7, 0.8, 2.9>, <0.7, 0.8, 4.7>, 0.7
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         plane {
            <0, 1, 0>, 0
            scale 1
            rotate z*69.4
            translate <0.51812, 0.8, 4>
         }
      }
      
      difference {
         //*PMName Sprocket
         
         cylinder {
            //*PMName Outer
            <15.9, 0.9, 3>, <15.9, 0.9, 4.6>, 0.9
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         cylinder {
            //*PMName Inner
            <15.9, 0.9, 2.9>, <15.9, 0.9, 4.7>, 0.75
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         plane {
            <0, 1, 0>, 0
            scale 1
            rotate z*(-64)
            translate <16.101, 0.96701, 4>
         }
      }
      
      box {
         //*PMName Lower
         <2.2, -1.25, 3>, <14.1, -1.4, 4.6>
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      box {
         //*PMName Rear lower
         <0, -1.25, 3>, <2.9, -1.4, 4.6>
         scale 1
         rotate z*33.8
         translate <13.3145, -0.242762, 0>
      }
      
      box {
         //*PMName Rear upper
         <0, -1.25, 3>, <2.1, -1.4, 4.6>
         scale 1
         rotate z*15.7
         translate <13.3574, 2.41879, 0>
      }
      
      box {
         //*PMName Upper
         <2.6, 1.05, 3>, <13.8, 1.2, 4.6>
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      box {
         //*PMName Front upper
         <0, -1.25, 3>, <2, -1.4, 4.6>
         scale 1
         rotate z*(-12.5)
         translate <1.03472, 2.85243, 0>
      }
      
      box {
         //*PMName Front lower
         <0, -1.25, 3>, <2.55, -1.4, 4.6>
         scale 1
         rotate z*(-37.4)
         translate <1.03077, 1.26951, 0>
      }
      
      pigment {
         Rust
      }
   }
   
   union {
      //*PMName Track left
      
      difference {
         //*PMName Idler
         
         cylinder {
            //*PMName Outer
            <0.7, 0.8, -3>, <0.7, 0.8, -4.6>, 0.85
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         cylinder {
            //*PMName Inner
            <0.7, 0.8, -2.9>, <0.7, 0.8, -4.7>, 0.7
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         plane {
            <0, 1, 0>, 0
            scale 1
            rotate z*69.4
            translate <0.51812, 0.8, -4>
         }
      }
      
      difference {
         //*PMName Sprocket
         
         cylinder {
            //*PMName Outer
            <15.9, 0.9, -3>, <15.9, 0.9, -4.6>, 0.9
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         cylinder {
            //*PMName Inner
            <15.9, 0.9, -2.9>, <15.9, 0.9, -4.7>, 0.75
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         plane {
            <0, 1, 0>, 0
            scale 1
            rotate z*(-64)
            translate <16.101, 0.967007, -4>
         }
      }
      
      box {
         //*PMName Lower
         <2.6, -1.25, -3>, <14.5, -1.4, -4.6>
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      box {
         //*PMName Rear lower
         <0, -1.25, -3>, <2.6, -1.4, -4.6>
         scale 1
         rotate z*40.2
         translate <13.6579, -0.357237, 0>
      }
      
      box {
         //*PMName Rear upper
         <0, -1.25, -3>, <1.8, -1.4, -4.6>
         scale 1
         rotate z*19.5
         translate <13.6579, 2.39017, 0>
      }
      
      box {
         //*PMName Upper
         <3, 1.05, -3>, <14.2, 1.2, -4.6>
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      box {
         //*PMName Front upper
         <0, -1.25, -3>, <2.3, -1.4, -4.6>
         scale 1
         rotate z*(-10.8)
         translate <0.986853, 2.862, 0>
      }
      
      box {
         //*PMName Front lower
         <0, -1.25, -3>, <2.8, -1.4, -4.6>
         scale 1
         rotate z*(-32.9)
         translate <0.992477, 1.29822, 0>
      }
      
      pigment {
         Rust
      }
   }
   
   union {
      //*PMName Headlights
      
      difference {
         //*PMName Light bodies
         
         union {
            //*PMName Lights
            
            sphere {
               //*PMName Left
               <0, 0, -0.35>, 0.25
               scale <1.4, 1, 1>
               rotate <0, 0, 0>
               translate <0, 0, 0>
            }
            
            sphere {
               //*PMName Right
               <0, 0, 0.35>, 0.25
               scale <1.4, 1, 1>
               rotate <0, 0, 0>
               translate <0, 0, 0>
            }
         }
         
         plane {
            <1, 0, 0>, 0
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
      }
      
      box {
         //*PMName Hood
         <0, 0.08, 0.55>, <-0.25, 0.17, 0.15>
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName IR lense
         <0, 0, -0.35>, <-0.01, 0, -0.35>, 0.2
         
         texture {
            Infrared
         }
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Cage front right
         <-0.3, 0.3, 0.7>, <-0.3, -0.5, 0.7>, 0.02
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Cage front centre
         <-0.3, 0.3, 0>, <-0.3, -0.5, 0>, 0.02
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Cage front left
         <-0.1, 0.3, -0.7>, <-0.1, -0.5, -0.7>, 0.02
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Cage rear right
         <0.4, 0.3, 0.7>, <0.4, -0.5, 0.7>, 0.02
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Cage rear centre
         <0.4, 0.3, 0>, <0.4, -0.5, 0>, 0.02
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Cage rear left
         <0.4, 0.3, -0.7>, <0.4, -0.5, -0.7>, 0.02
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Cage top right
         <-0.3, 0.3, 0.7>, <0.4, 0.3, 0.7>, 0.02
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Cage top centre
         <-0.3, 0.3, 0>, <0.4, 0.3, 0>, 0.02
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Cage top left
         <-0.1, 0.3, -0.7>, <0.4, 0.3, -0.7>, 0.02
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Cage top rear
         <0.4, 0.3, 0.7>, <0.4, 0.3, -0.7>, 0.02
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Cage top front left
         <-0.1, 0.3, -0.7>, <-0.1, 0.3, 0>, 0.02
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Cage top front right
         <-0.3, 0.3, 0>, <-0.3, 0.3, 0.7>, 0.02
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      translate <1.25, 2.5, 1.25>
   }
   
   pigment {
      Sand
   }
}

#declare Turret = union {
   //*PMName Turret
   
   difference {
      //*PMName Roof sections
      
      union {
         //*PMName Shape before roof cuts
         
         cylinder {
            //*PMName Right roof
            <1.15, 0, 0.65>, <1.15, 2.3, 0.65>, 2
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         cylinder {
            //*PMName Left roof
            <1.15, 0, -0.8>, <1.15, 2.3, -0.8>, 2
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         bicubic_patch {
            //*PMName Front roof
            type 0
            u_steps 3
            v_steps 3
            <-3.0048, 1.5156, -0.59551>, <-1.6812, 1.5254, -2.0993>, <-0.38759, 1.6613, -2.1496>, <1, 1.8575, -2.7983>,
            <-3.0205, 1.5156, -0.15872>, <-1.89, 2.073, -0.69221>, <-1.19554, 2.01476, -0.792708>, <-0.0975242, 2.17462, -0.79624>,
            <-3.0205, 1.5156, 0.26131>, <-1.9746, 1.90884, 0.75587>, <-1.18321, 1.99169, 0.8981>, <0.0264515, 2.19444, 0.882405>,
            <-3.0048, 1.5156, 0.59551>, <-1.6812, 1.5254, 2.0993>, <-0.38759, 1.6613, 2.1496>, <1, 1.8685, 2.6738>
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
      }
      
      plane {
         //*PMName Right roof cut
         <0, -1, 0>, 0
         scale 1
         rotate <8, 0, 2>
         translate <3.2, 2.2, -0.2>
      }
      
      plane {
         //*PMName Left roof cut
         <0, -1, 0>, 0
         scale 1
         rotate <-8, 0, 2>
         translate <3.2, 2.2, -0.2>
      }
   }
   
   bicubic_patch {
      //*PMName Rear wall
      type 0
      u_steps 3
      v_steps 3
      <1, 1.8575, -2.7983>, <1, 1.5342, -3.3686>, <1, 0.60826, -3.5112>, <1, 0, -3.6>,
      <4.03652, 2.00755, -3.21781>, <5.55114, 1.94621, -3.53327>, <5.58411, 1.91936, -3.16663>, <5.58959, 0, -3.56667>,
      <3.91703, 2.07331, 3.28196>, <5.06193, 2.33764, 3.54063>, <5.33407, 0.3413, 3.23337>, <5.57497, 0.0187509, 3.43327>,
      <1, 1.8685, 2.6738>, <1, 1.3013, 3.3048>, <1, 0.66812, 3.5067>, <1, 0, 3.6>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   bicubic_patch {
      //*PMName Left side
      type 0
      u_steps 3
      v_steps 3
      <1, 1.8575, -2.7983>, <1, 1.5342, -3.3686>, <1, 0.60826, -3.5112>, <1, 0, -3.6>,
      <-1.8272, 1.502, -1.6302>, <-1.2522, 1.2673, -2.6251>, <-1.3155, 0.91156, -2.9359>, <-1.3731, 0, -3.8183>,
      <-1.2118, 1.5716, -2.1577>, <-2.5415, 1.181, -1.9732>, <-2.9676, 0.80553, -2.2281>, <-3.2896, 0, -2.4136>,
      <-3.0048, 1.5156, -0.59551>, <-3.6995, 1.2028, -1.0147>, <-3.9034, 0.69061, -1.1455>, <-4.1209, -0.012116, -0.95875>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   bicubic_patch {
      //*PMName Right side
      type 0
      u_steps 3
      v_steps 3
      <1, 1.8685, -2.6738>, <1, 1.3013, -3.3048>, <1, 0.66812, -3.5067>, <1, 0, -3.6>,
      <-1.8272, 1.502, -1.6302>, <-1.2522, 1.2673, -2.6251>, <-1.3155, 0.91156, -2.9359>, <-1.3731, 0, -3.8183>,
      <-1.2118, 1.5716, -2.1577>, <-2.5415, 1.181, -1.9732>, <-2.9676, 0.80553, -2.2281>, <-3.2896, 0, -2.4136>,
      <-3.0048, 1.5156, -0.59551>, <-3.6995, 1.20284, -1.01472>, <-3.9034, 0.690606, -1.1455>, <-4.1209, -0.012116, -0.95875>
      scale <1, 1, -1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   difference {
      //*PMName Front
      
      blob {
         //*PMName Front
         threshold 0.01
         
         cylinder {
            <-3, 0, -0.75>, <-3, 0, 0.75>, 1.25,
            strength 1
         }
         scale <1, 1.25, 0.8>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      plane {
         <0, 1, 0>, 0
         scale 1
         rotate <0, 0, 0>
         translate x*(-3.5)
      }
   }
   
   union {
      //*PMName Commander's cupola
      
      cone {
         //*PMName Base
         <1.3, 2.2, -1.6>, 1,
         <1.3, 1.7, -1.6>, 1.25
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      sphere {
         //*PMName Hatch
         <0, 0, 0>, 0.8
         scale <1, 0.3, 1>
         rotate <0, 0, 0>
         translate <1.3, 2.2, -1.6>
      }
      
      box {
         //*PMName Front periscope
         <0.55, 2.2, -1.3>, <0.75, 2.5, -1.9>
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      box {
         //*PMName Right periscope
         <0, 2.2, -0.2>, <0.1, 2.4, 0.2>
         scale 1
         rotate y*45
         translate <0.8, 0, -1>
      }
      
      box {
         //*PMName Left periscope
         <0, 2.2, -0.2>, <0.1, 2.4, 0.2>
         scale 1
         rotate y*(-45)
         translate <0.8, 0, -2.2>
      }
   }
   
   union {
      //*PMName Loader's hatch
      
      cone {
         //*PMName Base
         <1.3, 2.2, 1.5>, 1,
         <1.3, 1.7, 1.5>, 1.25
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Hatch
         <1.3, 2.2, 1.5>, <1.3, 2.25, 1.5>, 0.7
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
   }
   
   difference {
      //*PMName Sight
      
      cylinder {
         //*PMName Body
         <-0.5, 1.7, -1.85>, <-0.5, 2.2, -1.85>, 0.3
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      plane {
         //*PMName Rear cut-off
         <0, -1, 0>, 0
         scale 1
         rotate z*(-45)
         translate <-0.3, 2.1, -0.85>
      }
      
      plane {
         //*PMName Front face
         <1, 0, 0>, 0
         scale 1
         rotate <0, 0, 0>
         translate <-0.7, 2.1, -0.85>
      }
   }
   
   cylinder {
      //*PMName Sight base
      <-0.5, 1, -1.85>, <-0.5, 1.8, -1.85>, 0.45
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   union {
      //*PMName Loader's periscope
      
      cylinder {
         //*PMName Base
         <-0.2, 1, 1.6>, <-0.2, 1.9, 1.6>, 0.3
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Periscope
         <-0.2, 1.9, 1.6>, <-0.2, 2.1, 1.6>, 0.2
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
   }
   
   union {
      //*PMName Gun barrel
      
      cone {
         //*PMName Collar
         <-4, 0.7, 0>, 0.5,
         <-5.5, 0.7, 0>, 0.3
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      difference {
         //*PMName Barrel
         
         cone {
            //*PMName Barrel
            <-5.5, 0.7, 0>, 0.3,
            <-15.7, 0.7, 0>, 0.2
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         cylinder {
            //*PMName Bore
            <-4, 0.7, 0>, <-16, 0.7, 0>, 0.143
            
            texture {
               pigment {
                  color rgb <0.823529, 0.823529, 0.823529>
               }
               
               finish {
                  metallic 1
               }
            }
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
      }
      
      cylinder {
         //*PMName Bore evacuator
         <-13, 0.7, 0>, <-15.4, 0.7, 0>, 0.27
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
   }
   
   intersection {
      //*PMName Mantlet cover
      
      cone {
         //*PMName Cover
         <-3, 0.7, 0>, 0.9,
         <-4.75, 0.7, 0>, 0.45
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      box {
         <-4.75, 0, -0.7>, <-3, 1.6, 0.7>
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
   }
   
   union {
      //*PMName Searchlight
      
      box {
         //*PMName Baseplate
         <-0.3, -0.6, -0.5>, <0.4, -0.7, 0.5>
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      box {
         //*PMName Mount right
         <-0.3, -0.7, 0.4>, <0.4, -1.5, 0.5>
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      box {
         //*PMName Mount left
         <-0.3, -0.7, -0.4>, <0.4, -1, -0.5>
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Front
         <-0.35, 0, 0>, <0, 0, 0>, 0.55
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Face
         <-0.35, 0, 0>, <-0.36, 0, 0>, 0.45
         
         texture {
            Infrared
         }
         scale 1
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      difference {
         //*PMName Rear
         
         sphere {
            //*PMName Rear
            <0, 0, 0>, 0.55
            scale <0.75, 1, 1>
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         plane {
            <1, 0, 0>, 0
            scale 1
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
      }
      translate <-3, 2.2, 1.5>
   }
   
   box {
      //*PMName Rear stowage box
      <5.4, 1.45, -1.6>, <7, 1.9, 1.6>
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   pigment {
      Sand
   }
   translate <8.2, 2.8, 0>
}

union {
   //*PMName Enigma
   
   object {
      //*PMName Hull
      Hull
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   object {
      //*PMName Hull front armour
      ArmourHullFront
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   object {
      //*PMName Hullside armour right
      ArmourHullsideRight
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   object {
      //*PMName Hullside armour left
      ArmourHullsideLeft
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   object {
      //*PMName Turret
      Turret
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   object {
      //*PMName Turret armour rear
      ArmourTurretRear
      scale 1
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   object {
      //*PMName Turret armour left
      ArmourTurretLeft
      scale 1
      rotate y*10
      translate <4, 2.8, -4.5>
   }
   
   object {
      //*PMName Turret armour right
      ArmourTurretRight
      scale 1
      rotate <-0.1, -10, 0>
      translate <3.9759, 2.8, 4.4759>
   }
   rotate <0, 0, 0>
   translate <0, 0, 0>
}

camera {
   perspective
   location <-5, 7, -12>
   sky <0, 1, 0>
   direction <0, 0, 1>
   right <1.3333, 0, 0>
   up <0, 1, 0>
   look_at <2, 2, 0>
   angle 90
}